---
title: XRSessionInit
slug: Web/API/XRSessionInit
tags:
  - API
  - AR
  - Dictionary
  - Reality
  - Reference
  - Session
  - VR
  - Virtual
  - WebXR API
  - WebXR Device API
  - WehXR
  - XR
  - XRSessionInit
  - augmented
---
<p>{{APIRef("WebXR Device API")}}{{draft}}</p>

<p>The <a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a> dictionary <code><strong>XRSessionInit</strong></code> specifies required and/or optional features when requesting a new {{domxref("XRSession")}} by calling the {{domxref("XRSystem.requestSession", "navigator.xr.requestSession()")}} method.</p>

<h2 id="Properties">Properties</h2>

<p>The following parameters are all optional. If none are included, the device will use {{anch("Default features", "a default feature configuration")}} for all options.</p>

<dl>
 <dt><code>optionalFeatures</code> {{optional_inline}}</dt>
 <dd>An array of values identifying features which the returned {{domxref("XRSession")}} may optionally support. At this time, all features are identified using strings from the {{domxref("XRReferenceSpaceType")}} enumeration, but future updates to the WebXR standard may add more features.</dd>
 <dt><code>requiredFeatures</code> {{optional_inline}}</dt>
 <dd>An array of values which the returned <code>XRSession</code> <em>must</em> support. These values currently must come from the enumerated type <code>XRReferenceSpaceType</code>. More features may be added in future updates to the WebXR standard.</dd>
</dl>

<h2 id="Default_features">Default features</h2>

<h3 id="Immersive_sessions">Immersive sessions</h3>

<p>All immersive (both <code>immersive-vr</code> and <code>immersive-ar</code>)  sessions support both the <code>viewer</code> and <code>local</code> reference spaces.</p>

<p>Because immersive sessions are required to support the <code>local</code> reference space, any request to open an immersive {{domxref("XRSession")}} is required to obtain <a href="/en-US/docs/Web/API/WebXR_Device_API#User_intent">explicit or implicit user consent</a>.</p>

<h3 id="Inline_sessions">Inline sessions</h3>

<p>All <code>inline</code> WebXR sessions support the <code>viewer</code> reference space.</p>

<h2 id="Security_requirements">Security requirements</h2>

<p>Each reference space or feature type has minimum safety requirements. By session type, those are:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Reference space type</th>
   <th scope="col">User consent rquirement</th>
   <th scope="col">Feature policy requirement</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>bounded-floor</code></td>
   <td>Always required</td>
   <td><code>xr-spatial-tracking</code></td>
  </tr>
  <tr>
   <td><code>local</code></td>
   <td>Always required for inline sessions</td>
   <td><code>xr-spatial-tracking</code></td>
  </tr>
  <tr>
   <td><code>local-floor</code></td>
   <td>Always required</td>
   <td><code>xr-spatial-tracking</code></td>
  </tr>
  <tr>
   <td><code>unbounded</code></td>
   <td>Always required</td>
   <td><code>xr-spatial-tracking</code></td>
  </tr>
  <tr>
   <td><code>viewer</code></td>
   <td>Always required</td>
   <td>—</td>
  </tr>
 </tbody>
</table>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API/Spatial_tracking">Spatial tracking in WebXR</a></li>
 <li>{{domxref("XRSession")}} </li>
</ul>
